# A More Complicated Makefile
OBJS = parser.cmo scanner.cmo printer.cmo interpret.cmo toplevel.cmo

toplevel.exe : $(OBJS)
	ocamlc -o toplevel.exe $(OBJS)
scanner.ml : scanner.mll
	ocamllex scanner.mll
parser.ml parser.mli : parser.mly
	ocamlyacc parser.mly
	
%.cmo : %.ml 
	ocamlc -c $<
%.cmi : %.mli
	ocamlc -c $<
	
.PHONY : clean
clean :
	rm -f toplevel.exe parser.ml parser.mli scanner.ml \
	testall.log *.cmo *.cmi

# Generated by ocamldep *.ml *.mli
interpret.cmo: ast.cmi
interpret.cmx: ast.cmi
toplevel.cmo: scanner.cmo parser.cmi interpret.cmo
toplevel.cmx: scanner.cmx parser.cmx interpret.cmx
parser.cmo: ast.cmi parser.cmi

#Running theMore ComplicatedMakefile
#$ make
#ocamlyacc parser.mly
#ocamlc c
#ast.mli
#ocamlc c
#parser.mli
#ocamlc c
#parser.ml
#ocamllex scanner.mll
#49 states, 1995 transitions, table size 8274 bytes
#ocamlc c
#scanner.ml
#ocamlc c
#printer.ml
#ocamlc c
#interpret.ml
#ocamlc c
#toplevel.ml
#ocamlc o
#toplevel parser.cmo scanner.cmo printer.cmo \
#interpret.cmo toplevel.cmo
#$ rm toplevel.cmo
#$ make
#ocamlc c
#toplevel.ml
#ocamlc o
#toplevel parser.cmo scanner.cmo printer.cmo \
#interpret.cmo toplevel.cmo
#$ make clean
#rm f
#toplevel parser.ml parser.mli scanner.ml \
#testall.log *.cmo *.cmi
